/****************************************************************************

	File    : Server\program\program_ser.c  

	Project : Server.c
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/program/program_ser.h"
#include "Server/program/program.h"
#include "Server/program/program_opt.h"
#include "Server/program/program_srr.h"
#include "Server/standard/standard_ser.h"
#include <errno.h>


// ------------------------------------------------------> pr_Completing <---

void pr_Completing(void)
{
	if (pp) {
		CloseProgram ();
		pp = false;
	}
}


// --------------------------------------------------> pr_Initialization <---

void pr_Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	pr_parms_t parms;

							//    
	pr_OptProc (argc, argv, &parms);

							//   
	InitProgram ();
	pp = true;

							//    
	*path  = (const char*) PROGRAM_NAME;
	*flags = 0; // NAME_FLAG_ATTACH_GLOBAL
	*rsize = sizeof (pr_r_msg_t);
	*psize = sizeof (pr_p_msg_t);
}

// -------------------------------------------------> pr_ChannelDepended <---

void pr_ChannelDepended(int coid)
{
	st_ChannelDepended (coid);
}

// ------------------------------------------------------> pr_ProcessMsg <---

int pr_ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int status;
	uint16_t type;

	type = ((st_r_cmd_t*) r_msg)->type;

	*psize = 0;
	status = ENOSYS;

	switch (type) {

	// --->

	case pr_t_t1:
		status = Func ();
		break;

	// <---    

	default:
		status = st_ProcessMsg (rcvid, r_msg, p_msg, psize, info);
		break;
	}

	return status;
}

// ----------------------------------------------------> pr_ProcessPulse <---

void pr_ProcessPulse(struct _pulse* pulse, struct _msg_info* info)
{
	switch (pulse->code) {

	// --->



	// <---

	default:
		st_ProcessPulse(pulse, info);
		break;
	}
}


//===========================================================================

