/****************************************************************************

	File    : Server\standard\standard_lib.c  

	Project : Server.c
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/standard/standard_lib.h"
#include "Server/standard/standard_srr.h"
#include <err.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/dispatch.h>


/*
 ,  st_Open()  st_Close()    
.   st_Open()     , 
.  st_Close() ,    st_Open().
*/



const char* st_name = STANDARD_NAME;

static int rc;

// ------------------------------------------------------------> st_Open <---

int st_Open(const char* name, unsigned int flags)
{
	/*
	  100       
	  50 . ,     5  , 
	      .
	*/

	int i;

	for (i = 0; i < 100; i++) {
		rc = name_open (name, flags);

		if (rc == -1 && errno == ENOENT)
			delay (50);
		else
			break;
	}

	return rc;
}

// ---------------------------------------------------------> st_OpenErr <---

int st_OpenErr(const char* name, unsigned int flags)
{
	rc = st_Open (name, flags);
							if (rc == -1) err (EXIT_FAILURE,
							"Can not open '%s'", name);

	return rc;
}

// -----------------------------------------------------------> st_Close <---

int st_Close(int fd)
{
	rc = name_close (fd);

	return rc;
}

// --------------------------------------------------------> st_Complete <---

int st_Complete(int fd)
{
	st_r_cmd_t s_msg;

	s_msg.type = st_t_quit;
	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// -------------------------------------------------> st_CompleteByPulse <---

int st_CompleteByPulse(int fd)
{
	rc = MsgSendPulse (fd, SIGEV_PULSE_PRIO_INHERIT, st_c_quit, 0);

	return rc;
}

// ----------------------------------------------> st_EventForDelivering <---

int st_EventForDelivering(int fd, struct sigevent* event)
{
	st_r_evdlvr_t s_msg;

	s_msg.type  = st_t_evdlvr;
	s_msg.event = *event;
	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}


//===========================================================================

