/****************************************************************************

	File    : Server\standard\standard_lib.h  

	Project : Server.c
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef standard_lib_h
#define standard_lib_h

#include <sys/siginfo.h>

//    .

//  
extern const char* st_name;

/* 
// st_Open
// --------
//          .
// 
//   .
//
// name: [In] -  
// flags: [In] -   ,   
*/
int st_Open(const char* name, unsigned int flags);

/* 
// st_OpenErr
// --------
//             .
//        .
// 
//   .
//
// name: [In] -  
// flags: [In] -   ,   
*/
int st_OpenErr(const char* name, unsigned int flags);

/* 
// st_Close
// --------
//       .
//
// fd: [In] -  
*/
int st_Close(int fd);

/* 
// st_Complete
// --------
//     .
//
// fd: [In] -  
*/
int st_Complete(int fd);

/* 
// st_CompleteByPulse
// --------
//     ,  .
//
// fd: [In] -  
*/
int st_CompleteByPulse(int fd);

/* 
// st_EventForDelivering
// --------
//         .
//
// fd: [In] -  
// event: [In] -   
*/
int st_EventForDelivering(int fd, struct sigevent* event);

#endif

//===========================================================================

