/****************************************************************************

	File    : Server\standard\standard_opt.c  

	Project : Server.c
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/standard/standard_opt.h"
#include "Server/standard/standard_srr.h"
#include "Server/tools/tools.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/dispatch.h>


// ==============================================================> usage <===
/*
#ifdef __USAGE
%C - minimal server

%C [-n name] [-g] &
 -n register the name (default "standard")
 -g register as global 
Options:

Examples:
%C -n test -g &
%C -g &
#endif
*/



static st_parms_t parms_def = {STANDARD_NAME, 0};

static void Opt_n(char* optarg);

static void Opt_g(char* optarg);

// ---------------------------------------------------------> st_OptProc <---

void st_OptProc(int argc, char** argv, st_parms_t* parms)
{
	int c;

	    						//   ,
	    						//    
	opterr = 0;
	while (1) {
		c = getopt (argc, argv, "n:g");   // <---

		if (c == -1 && argv[optind] == NULL)
			break;

		switch (c) {

		// --->

		case 'n': 
			Opt_n (optarg); 
			break;

		case 'g': 
			Opt_g (optarg); 
			break;

		// <---    

		default:
			Usage ();
			exit (EXIT_FAILURE);
			break;
		}
	}

	*parms = parms_def;
}

// --------------------------------------------------------------> Opt_n <---

static void Opt_n(char* optarg)
{
	parms_def.name = optarg;
}

// --------------------------------------------------------------> Opt_g <---

static void Opt_g(char* optarg)
{
	parms_def.flag = NAME_FLAG_ATTACH_GLOBAL;
}


//===========================================================================

