/****************************************************************************

	File    : Server\standard\standard_ser.c  

	Project : Server.c
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/standard/standard_ser.h"
#include "Server/standard/standard.h"
#include "Server/standard/standard_opt.h"
#include "Server/standard/standard_srr.h"
#include "Server/server_fix/server_fix.h"
#include <err.h>
#include <errno.h>


bool pp = false;

// ------------------------------------------------------> st_Completing <---

void st_Completing(void)
{
	if (pp) {
		CloseStandard ();
		pp = false;
	}

	ServerFixCompleting ();
}


// --------------------------------------------------> st_Initialization <---

void st_Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	st_parms_t parms;

							//    
	st_OptProc (argc, argv, &parms);

							//   
	InitStandard ();
	pp = true;

							//    
	*path  = (const char*) parms.name;
	*flags = parms.flag;
	*rsize = sizeof (st_r_msg_t);
	*psize = sizeof (st_p_msg_t);
}

// -------------------------------------------------> st_ChannelDepended <---

void st_ChannelDepended(int coid)
{
}

// ------------------------------------------------------> st_ProcessMsg <---

int st_ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int status;
	uint16_t type;

	type = ((st_r_cmd_t*) r_msg)->type;

	*psize = 0;
	status = ENOSYS;

	switch (type) {

	case st_t_quit:
		status = Complete (&is_srr_running);
		break;

	case st_t_evdlvr: {
		st_r_evdlvr_t* rmsg = (st_r_evdlvr_t*) r_msg;
		status = EventForDelivering (rcvid, &(rmsg->event));
		break;
	}

	case _IO_CONNECT:
	case _IO_CLOSE:
		status = EOK;
		break;

	default:
		warnx ("unsupported command type=%d", type);
		status = ENOSYS;
		break;
	}

	return status;
}

// ----------------------------------------------------> st_ProcessPulse <---

void st_ProcessPulse(struct _pulse* pulse, struct _msg_info* info)
{
	switch (pulse->code) {

	case st_c_quit:
		CompleteByPulse (&is_srr_running);
		break;

	case _PULSE_CODE_DISCONNECT:
		ConnectDetach (pulse->scoid);
		break;

	case _PULSE_CODE_UNBLOCK:
	case _PULSE_CODE_THREADDEATH:
	case _PULSE_CODE_COIDDEATH:
	case _PULSE_CODE_NET_ACK:
	case _PULSE_CODE_NET_UNBLOCK:
	case _PULSE_CODE_NET_DETACH:
		break;

	default:
		warnx ("unsupported pulse code=%d", pulse->code);
		break;
	}
}


//===========================================================================

